#pragma once
#include <math.h>


// --------------------------------------------------------------------------------
// CMyFilter
// --------------------------------------------------------------------------------
class CMyFilter
{
private:
	// tB^̌W
	float a0, a1, a2, b0, b1, b2;
	// obt@
	float out1, out2;
	float in1, in2;

public:
	inline CMyFilter();

	// ͐MɃtB^Kp֐
	inline float Process(float in);

	// tB^WvZ郁o[֐
	inline void LowPass  (float freq, float q , float samplerate = 44100.0f);
	inline void HighPass (float freq, float q , float samplerate = 44100.0f);
	inline void BandPass (float freq, float bw, float samplerate = 44100.0f);
	inline void Notch    (float freq, float bw, float samplerate = 44100.0f);
	inline void LowShelf (float freq, float q , float gain, float samplerate = 44100.0f);
	inline void HighShelf(float freq, float q , float gain, float samplerate = 44100.0f);
	inline void Peaking  (float freq, float bw, float gain, float samplerate = 44100.0f);
	inline void AllPass  (float freq, float q , float samplerate = 44100.0f);
};

// --------------------------------------------------------------------------------
// RXgN^
// --------------------------------------------------------------------------------
CMyFilter::CMyFilter()
{
	// o[ϐ
	a0 = 1.0f; // 0ȊOɂĂȂƏZŃG[ɂȂ
	a1 = 0.0f;
	a2 = 0.0f;
	b0 = 1.0f;
	b1 = 0.0f;
	b2 = 0.0f;

	in1 = 0.0f;
	in2 = 0.0f;

	out1 = 0.0f;
	out2 = 0.0f;
}

// --------------------------------------------------------------------------------
// ͐MɃtB^Kp֐
// --------------------------------------------------------------------------------
float CMyFilter::Process(float in)
{
	// ͐MɃtB^KpAo͐MϐɕۑB
	float out = b0 / a0 * in + b1 / a0 * in1 + b2 / a0 * in2
		- a1 / a0 * out1 - a2 / a0 * out2;

	in2 = in1; // 2O̓͐MXV
	in1 = in;  // 1O̓͐MXV

	out2 = out1; // 2Ȍo͐MXV
	out1 = out;  // 1Ȍo͐MXV

	// o͐MԂ
	return out;
}

// --------------------------------------------------------------------------------
// tB^WvZ郁o[֐
// --------------------------------------------------------------------------------
void CMyFilter::LowPass(float freq, float q, float samplerate)
{
	// tB^WvZŎgp钆Ԓl߂B
	float omega = 2.0f * 3.14159265f *  freq / samplerate;
	float alpha = sin(omega) / (2.0f * q);

	// tB^W߂B
	a0 = 1.0f + alpha;
	a1 = -2.0f * cos(omega);
	a2 = 1.0f - alpha;
	b0 = (1.0f - cos(omega)) / 2.0f;
	b1 = 1.0f - cos(omega);
	b2 = (1.0f - cos(omega)) / 2.0f;
}

void CMyFilter::HighPass(float freq, float q, float samplerate)
{
	// tB^WvZŎgp钆Ԓl߂B
	float omega = 2.0f * 3.14159265f *  freq / samplerate;
	float alpha = sin(omega) / (2.0f * q);

	// tB^W߂B
	a0 = 1.0f + alpha;
	a1 = -2.0f * cos(omega);
	a2 = 1.0f - alpha;
	b0 = (1.0f + cos(omega)) / 2.0f;
	b1 = -(1.0f + cos(omega));
	b2 = (1.0f + cos(omega)) / 2.0f;
}

void CMyFilter::BandPass(float freq, float bw, float samplerate)
{
	// tB^WvZŎgp钆Ԓl߂B
	float omega = 2.0f * 3.14159265f *  freq / samplerate;
	float alpha = sin(omega) * sinh(log(2.0f) / 2.0 * bw * omega / sin(omega));

	// tB^W߂B
	a0 = 1.0f + alpha;
	a1 = -2.0f * cos(omega);
	a2 = 1.0f - alpha;
	b0 = alpha;
	b1 = 0.0f;
	b2 = -alpha;
}

void CMyFilter::Notch(float freq, float bw, float samplerate)
{
	// tB^WvZŎgp钆Ԓl߂B
	float omega = 2.0f * 3.14159265f *  freq / samplerate;
	float alpha = sin(omega) * sinh(log(2.0f) / 2.0 * bw * omega / sin(omega));

	// tB^W߂B
	a0 = 1.0f + alpha;
	a1 = -2.0f * cos(omega);
	a2 = 1.0f - alpha;
	b0 = 1.0f;
	b1 = -2.0f * cos(omega);
	b2 = 1.0f;
}

void CMyFilter::LowShelf(float freq, float q, float gain, float samplerate)
{
	// tB^WvZŎgp钆Ԓl߂B
	float omega = 2.0f * 3.14159265f *  freq / samplerate;
	float alpha = sin(omega) / (2.0f * q);
	float A = pow(10.0f, (gain / 40.0f));
	float beta = sqrt(A) / q;

	// tB^W߂B
	a0 = (A + 1.0f) + (A - 1.0f) * cos(omega) + beta * sin(omega);
	a1 = -2.0f * ((A - 1.0f) + (A + 1.0f) * cos(omega));
	a2 = (A + 1.0f) + (A - 1.0f) * cos(omega) - beta * sin(omega);
	b0 = A * ((A + 1.0f) - (A - 1.0f) * cos(omega) + beta * sin(omega));
	b1 = 2.0f * A * ((A - 1.0f) - (A + 1.0f) * cos(omega));
	b2 = A * ((A + 1.0f) - (A - 1.0f) * cos(omega) - beta * sin(omega));
}

void CMyFilter::HighShelf(float freq, float q, float gain, float samplerate)
{
	// tB^WvZŎgp钆Ԓl߂B
	float omega = 2.0f * 3.14159265f *  freq / samplerate;
	float alpha = sin(omega) / (2.0f * q);
	float A = pow(10.0f, (gain / 40.0f));
	float beta = sqrt(A) / q;

	// tB^W߂B
	a0 = (A + 1.0f) - (A - 1.0f) * cos(omega) + beta * sin(omega);
	a1 = 2.0f * ((A - 1.0f) - (A + 1.0f) * cos(omega));
	a2 = (A + 1.0f) - (A - 1.0f) * cos(omega) - beta * sin(omega);
	b0 = A * ((A + 1.0f) + (A - 1.0f) * cos(omega) + beta * sin(omega));
	b1 = -2.0f * A * ((A - 1.0f) + (A + 1.0f) * cos(omega));
	b2 = A * ((A + 1.0f) + (A - 1.0f) * cos(omega) - beta * sin(omega));
}


void CMyFilter::Peaking(float freq, float bw, float gain, float samplerate)
{
	// tB^WvZŎgp钆Ԓl߂B
	float omega = 2.0f * 3.14159265f *  freq / samplerate;
	float alpha = sin(omega) * sinh(log(2.0f) / 2.0 * bw * omega / sin(omega));
	float A = pow(10.0f, (gain / 40.0f));

	// tB^W߂B
	a0 = 1.0f + alpha / A;
	a1 = -2.0f * cos(omega);
	a2 = 1.0f - alpha / A;
	b0 = 1.0f + alpha * A;
	b1 = -2.0f * cos(omega);
	b2 = 1.0f - alpha * A;
}

void CMyFilter::AllPass(float freq, float q, float samplerate)
{
	// tB^WvZŎgp钆Ԓl߂B
	float omega = 2.0f * 3.14159265f *  freq / samplerate;
	float alpha = sin(omega) / (2.0f * q);

	// tB^W߂B
	a0 = 1.0f + alpha;
	a1 = -2.0f * cos(omega);
	a2 = 1.0f - alpha;
	b0 = 1.0f - alpha;
	b1 = -2.0f * cos(omega);
	b2 = 1.0f + alpha;
}