// VSTp̃CN[ht@C
#include "myvst3fuid.h"
#include "processor.h"


// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {


// ===================================================================================
// RXgN^
// ===================================================================================
MyVSTProcessor::MyVSTProcessor()
{
	// Rg[[FUIDݒ肷
	setControllerClass(ControllerUID);
}

// ===================================================================================
// NX֐
// ===================================================================================
tresult PLUGIN_API MyVSTProcessor::initialize(FUnknown* context)
{
	// ܂pNX̏{
	tresult result = AudioEffect::initialize(context);
	if (result == kResultTrue)
	{
		// ͂Əo͂ݒ
		addAudioOutput(STR16("AudioOutput"), SpeakerArr::kStereo);

		// ͂EventBusǉ
		addEventInput(STR16("Event Input"), 1);

		// ȉŗL̏{B
		volume = 0.0f;
		theta = 0.0f;
		pitchList.clear();
	}


	// kResultTrueԂB
	return result;
}

tresult PLUGIN_API MyVSTProcessor::setBusArrangements(SpeakerArrangement* inputs, int32 numIns, SpeakerArrangement* outputs, int32 numOuts)
{
	// inputoutput̃oX1ŁAinputoutput̍\XeȈꍇ
	if (numOuts == 1 && outputs[0] == SpeakerArr::kStereo)
	{
		return AudioEffect::setBusArrangements(inputs, numIns, outputs, numOuts);
	}

	// ΉĂȂoX\̏ꍇAkResultFalseԂB
	return kResultFalse;
}

// ===================================================================================
// M֐
// ===================================================================================
tresult PLUGIN_API MyVSTProcessor::process(ProcessData& data)
{
	// p[^[ύX̏
	// ^ꂽp[^[ƂAdatainputParameterChanges
	// IParameterChangesNXւ̃|C^̃AhX
	if (data.inputParameterChanges != NULL)
	{
		// ^ꂽp[^[̐擾
		int32 paramChangeCount = data.inputParameterChanges->getParameterCount();

		// ^ꂽp[^[AJԂB
		for (int32 i = 0; i < paramChangeCount; i++)
		{
			// p[^[ύX̃L[擾
			// (Tvɕ̃p[^[ύX񂪂\邽߁A
			// L[Ƃ`ɂȂĂB)
			IParamValueQueue* queue = data.inputParameterChanges->getParameterData(i);
			if (queue != NULL)
			{
				// ǂ̃p[^[ύXꂽm邽߁Ap[^[tag擾
				int32 tag = queue->getParameterId();

				// ύXꂽ񐔂擾
				int32 valueChangeCount = queue->getPointCount();
				ParamValue value;
				int32 sampleOffset;

				// ŌɕύXꂽl擾
				if (queue->getPoint(valueChangeCount - 1, sampleOffset, value) == kResultTrue)
				{
					// tagɉ{
					switch (tag)
					{
						// ̓p[^Ȃ̂ŉȂ
					}
				}
			}
		}
	}

	// Cxg̏
	// ^ꂽCxgƂdatainputEvents
	// IEventListNXւ̃|C^̃AhX
	IEventList* eventList = data.inputEvents;
	if (eventList != NULL)
	{
		// Cxg̐擾B
		int32 numEvent = eventList->getEventCount();
		for (int32 i = 0; i < numEvent; i++)
		{
			// iԖڂ̃Cxgf[^擾
			Event event;
			if (eventList->getEvent(i, event) == kResultOk)
			{
				int16 channel;
				int16 noteNo;
				float velocity;

				// Cxgf[^̃^CvƂɐU蕪
				switch (event.type)
				{
				case Event::kNoteOnEvent: // m[gICxg̏ꍇ
					channel = event.noteOn.channel;
					noteNo = event.noteOn.pitch;
					velocity = event.noteOn.velocity;

					onNoteOn(channel, noteNo, velocity);

					break;

				case Event::kNoteOffEvent: // m[gItCxg̏ꍇ
					channel = event.noteOff.channel;
					noteNo = event.noteOff.pitch;
					velocity = event.noteOff.velocity;

					onNoteOff(channel, noteNo, velocity);
					break;
				}
			}
		}
	}

	// ́Eo̓obt@̃|C^킩₷ϐɊi[
	// inputs[]Aoutputs[]AudioBus̐(addAudioInput()AaddAudioOutput()Œǉ)
	// AudioBus1Ȃ̂ 0 ݂̂ƂȂ
	// channelBuffers3232bit_^̃obt@ŉM̃`l
	// m(kMono)Ȃ 0 ݂̂ŁAXeI(kStereo)Ȃ 0(Left)  1(Right) ƂȂ
	Sample32* outL = data.outputs[0].channelBuffers32[0];
	Sample32* outR = data.outputs[0].channelBuffers32[1];

	// numSamplesŎTvA
	for (int32 i = 0; i < data.numSamples; i++)
	{
		// IV[^[̉擾B
		float pitch = 0.0f;

		// Xg̃TCY0łȂꍇA
		if (pitchList.size() != 0)
		{
			// ŌɉꂽMIDIm[g̉擾
			pitch = pitchList[pitchList.size() - 1];
		}

		// pxƂɉɉpx
		// (ł̓Tv[g44100HzŒŌvZĂ̂ŕKvɉď)
		theta += (2.0f * 3.14159265f * pitch) / 44100.0f;

		// {[ƃIV[^(sin()֐)̒l(U)vZďo͂
		// (ˑR傫ȉłƂ܂̂łƂ肠0.3f|Ă)
		outL[i] = 0.3f * volume * sin(theta);
		outR[i] = 0.3f * volume * sin(theta);
	}

	// ȂkResultTrueԂ(炭KkResultTrueԂ)
	return kResultTrue;
}


void MyVSTProcessor::onNoteOn(int channel, int note, float velocity)
{
	// MIDIm[gICxg̏s

	// ȒPȃTvȂ̂ŁAchannelvelocity͖

	// ꂽm[gAvZ
	// m[gNo.69440HzɂȂBɌvZB
	// vZ̏ڍאɂĂ͊
	float pitch = (440.0f * powf(2.0f, (float)(note - (69)) / 12.0));

	// pitchList̍Ōɒǉ
	pitchList.push_back(pitch);

	// {[0.0fƉoȂ̂ł1.0fɂĂ
	volume = 1.0f;

}

void MyVSTProcessor::onNoteOff(int channel, int note, float velocity)
{
	// MIDIm[gItCxg̏s

	// ȒPȃTvȂ̂ŁAchannelvelocity͖

	// ꂽm[gAvZ
	float pitch = (440.0f * powf(2.0f, (float)(note - (69)) / 12.0));

	// pitchListŏ猟Apitchɍv̂폜
	for (int i = 0; i < (int)pitchList.size(); i++)
	{
		if (pitchList[i] == pitch)
		{
			// pitchƍv̂ꍇA
			// Yf[^菜ČI
			pitchList.erase(pitchList.begin() + i);
			break;
		}
	}

	// pitchList̃TCY0̏ꍇA܂艟ꂽm[gȂꍇA
	// {[0.0fɂĉ
	if (pitchList.size() == 0)
	{
		volume = 0.0f;
	}

}


} } // namespace SteinbergVst̏I