// VSTp̃CN[ht@C
#include "myvst3def.h"
#include "myvst3fuid.h"
#include "processor.h"


// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {


// ============================================================================================
// RXgN^
// ============================================================================================
MyVSTProcessor::MyVSTProcessor()
{
	// Rg[[FUIDݒ肷
	setControllerClass(ControllerUID);
}

// ============================================================================================
// NX֐
// ============================================================================================
tresult PLUGIN_API MyVSTProcessor::initialize(FUnknown* context)
{
	// ܂pNX̏{
	tresult result = AudioEffect::initialize(context);
	if (result == kResultTrue)
	{
		// ͂Əo͂AudioBusǉ
		addAudioInput(STR16("AudioInput"), SpeakerArr::kStereo);
		addAudioOutput(STR16("AudioOutput"), SpeakerArr::kStereo);

		// ͂EventBusǉ
		addEventInput(STR16("Event Input"), 1);

		// ȉŗL̏{
		depth = 1.0f;
		freq = 5.0f;
		type = 0;

		theta = 0.0f;
	}

	// kResultTrueԂ
	return result;
}


tresult PLUGIN_API MyVSTProcessor::setBusArrangements(SpeakerArrangement* inputs, int32 numIns, SpeakerArrangement* outputs, int32 numOuts)
{
	// inputoutput̃oX1ŁAinputoutput̍\XeȈꍇ
	if (numIns == 1 && numOuts == 1 && inputs[0] == SpeakerArr::kStereo && outputs[0] == SpeakerArr::kStereo)
	{
		return AudioEffect::setBusArrangements(inputs, numIns, outputs, numOuts);
	}

	// ΉĂȂoX\̏ꍇAkResultFalseԂB
	return kResultFalse;
}


// ============================================================================================
// M֐
// ============================================================================================
tresult PLUGIN_API MyVSTProcessor::process(ProcessData& data)
{
	// p[^[ύX̏
	// ^ꂽp[^[ƂAdatainputParameterChanges
	// IParameterChangesNXւ̃|C^̃AhX
	if (data.inputParameterChanges != NULL)
	{
		// ^ꂽp[^[̐擾
		int32 paramChangeCount = data.inputParameterChanges->getParameterCount();

		// ^ꂽp[^[AJԂB
		for (int32 i = 0; i < paramChangeCount; i++)
		{
			// p[^[ύX̃L[擾
			// (Tvɕ̃p[^[ύX񂪂\邽߁A
			// L[Ƃ`ɂȂĂB)
			IParamValueQueue* queue = data.inputParameterChanges->getParameterData(i);
			if (queue != NULL)
			{
				// ǂ̃p[^[ύXꂽm邽߁Ap[^[tag擾
				int32 tag = queue->getParameterId();

				// ύXꂽ񐔂擾
				int32 valueChangeCount = queue->getPointCount();
				ParamValue value;
				int32 sampleOffset;

				// ŌɕύXꂽl擾
				if (queue->getPoint(valueChangeCount - 1, sampleOffset, value) == kResultTrue)
				{
					// tagɉ{
					switch (tag)
					{
					case PARAM_DEPTH_TAG:
						// depthύXB
						depth = value;
						break;
					case PARAM_SPEED_TAG:
						// depthύXB
						// RangeParameterō쐬ꂽp[^[AvZbTNXɓnƂ
						// 0.0`1.0ƂȂĂ܂B
						// ŊeRangeParameterɉ͈͂ݒ肷KvB
						freq = (29.5f * value) + 0.5f; // 0.5`30.0̊ԂɕύX
						break;
					case PARAM_TYPE_TAG:
						// typeύXB
						// StringListParameterō쐬ꂽp[^[AvZbTNX
						// nƂ0.0`1.0ƂȂĂ܂B
						// ̓Xg3Ȃ̂ŁAVolumec0.0fATremoloc0.5fAPanningc1.0fƂȂB
						// Xg̐4̏ꍇA0.0fA0.333cA0.666cA1.0fƂȂB
						// u1.0f / (Xg̐ - 1)vŋ߂B
						type = (int32)(value * 2.0f);
						break;
					}
				}
			}
		}
	}

	// ́Eo̓obt@̃|C^킩₷ϐɊi[
	// inputs[]Aoutputs[]AudioBus̐(addAudioInput()AaddAudioOutput()Œǉ)
	// AudioBus1Ȃ̂ 0 ݂̂ƂȂ
	// channelBuffers3232bit_^̃obt@ŉM̃`l
	// m(kMono)Ȃ 0 ݂̂ŁAXeI(kStereo)Ȃ 0(Left)  1(Right) ƂȂ
	Sample32* inL = data.inputs[0].channelBuffers32[0];
	Sample32* inR = data.inputs[0].channelBuffers32[1];
	Sample32* outL = data.outputs[0].channelBuffers32[0];
	Sample32* outR = data.outputs[0].channelBuffers32[1];

	// G[Bꕔ̃zXgAv(DAWȂ)nullptrƂȂ\邽
	if (inL == nullptr || inR == nullptr || outL == nullptr || outR == nullptr) { return kResultTrue; }

	// numSamplesŎTvA
	for (int32 i = 0; i < data.numSamples; i++)
	{
		// sin֐̌ʂ0`1̊Ԃɂ(gApp)
		Sample32 a = (sin(theta) * 0.5f) + 0.5f;

		// deptha͐MɊ|킹lvZ
		Sample32 b = (1.0f - depth) + (a * depth);
		Sample32 c = (1.0f - depth) + ((1.0f - a) * depth);

		switch (type)
		{
		case 0: // {[̏ꍇ
			// ͐Mdepth|킹(قǂab͖)
			outL[i] = depth * inL[i];
			outR[i] = depth * inR[i];
			break;

		case 1: // g̏ꍇ
			// ͐Mb|킹(Eʂɂ̂b̂ݎgp)
			outL[i] = b * inL[i];
			outR[i] = b * inR[i];
			break;

		case 2: // p̏ꍇ
			// ͐MbAc|킹(EňقȂ鉹ʂɂ)
			outL[i] = b * inL[i];
			outR[i] = c * inR[i];
			break;
		}

		// pxƂɊpx
		theta += (2.0f * 3.14159265f * freq) / 44100.0f;
	}

	// ȂkResultTrueԂ(炭KkResultTrueԂ)
	return kResultTrue;
}


} } // namespace SteinbergVst̏I
